web-app/project/web/models/captcha.py
from project import db


class Captcha(db.Model):
    __tablename__ = "captchas"
    id = db.Column(db.Integer, primary_key=True, autoincrement=True)
    captcha_uuid = db.Column(db.String(128), nullable=False)
    captcha_solved = db.Column(db.String(128))

    def __init__(self, uuid, solved):
        self.captcha_uuid = uuid
        self.captcha_solved = solved

    def save(self):
        if self.id is None:
            db.session.add(self)
        return db.session.commit()

    @staticmethod
    def check_captcha(uuid, solved_text):
        c = Captcha.query.filter_by(
            captcha_uuid=uuid, captcha_solved=solved_text
        ).first()
        print(c)
        return c is not None

web-app/project/web/models/user.py
from sqlalchemy.sql import func
from werkzeug.security import check_password_hash, generate_password_hash

from project import db


class User(db.Model):
    __tablename__ = "users"
    id = db.Column(db.Integer, primary_key=True, autoincrement=True)
    username = db.Column(db.String(128), nullable=False)
    password_hash = db.Column(db.String(128))
    role = db.Column(db.String(128), nullable=False)
    created_date = db.Column(db.DateTime, default=func.now(), nullable=False)

    def set_password(self, password):
        self.password_hash = generate_password_hash(password)

    def check_password(self, password):
        return check_password_hash(self.password_hash, password)

    def __init__(self, username, role):
        self.username = username
        self.role = role

web-app/project/__init__.py
import json
import logging
import os
from datetime import datetime

from flask import Flask
from flask_sqlalchemy import SQLAlchemy
from flask_toastr import Toastr
from flask_wtf.csrf import CSRFProtect

from project.healthcheck import Healthchecker
from project.web.services.mongo_service import update_picture
from project.web.services.kafka_service import produce

logging.basicConfig()

csrf = CSRFProtect()

db = SQLAlchemy()

APP_VERSION = os.getenv("APP_VERSION")

toastr = Toastr()

if os.getenv("STAGING") == "True":
    STAGING = True
    elastic = None
else:
    STAGING = False
    h = Healthchecker("flask_app")
    elastic = h.get_es()


if not os.path.exists("project/static/uploads/black"):
    os.makedirs("project/static/uploads/black")

if not os.path.exists("project/static/uploads/color"):
    os.makedirs("project/static/uploads/color")

if not os.path.exists("project/static/uploads/tmp"):
    os.makedirs("project/static/uploads/tmp")


def create_app(test_config=None):
    # create and configure the app
    app = Flask(__name__, instance_relative_config=True, template_folder="templates")
    if test_config is None:
        app_settings = os.getenv("APP_SETTINGS")
    else:
        app_settings = test_config
    app.config.from_object(app_settings)
    print(
        "FILE MAX CONTENT: {} mb".format(
            (app.config["MAX_CONTENT_LENGTH"] / (1024 * 1024))
        )
    )
    toastr.init_app(app)

    csrf.init_app(app)

    db.init_app(app)

    @app.shell_context_processor
    def ctx():
        return {"app": app, "db": db}

    @app.context_processor
    def inject_now():
        return {"now": datetime.utcnow()}

    from project.web.routes import admin, home, user

    app.register_blueprint(admin.bp)
    app.register_blueprint(home.bp)
    app.register_blueprint(user.bp)

    from project.web.routes.errors import page_not_found

    app.register_error_handler(404, page_not_found)
    # app.register_error_handler(413, request_too_large)

    host = os.environ.get("RABBITMQ_IP")
    port = 5671
    results_exchange = "results_exchange"

    # with app.app_context():
    from project.web.services.mqtt_consumer import Consumer

    def mqtt_callback(ch, method, properties, body):
        json_obj = json.loads(body)
        json_obj["filename"] = json_obj["filename"].replace("black", "color")
        produce("predictions", json_obj)
        update_picture(json_obj)
        # save in mongodb new image
        # save in folder the image

    Consumer(host, port, results_exchange, "fanout", "", mqtt_callback, app)

    return app

web-app/project/web/routes/admin.py
import functools

from flask import (
    Blueprint,
    flash,
    redirect,
    render_template,
    request,
    session,
    url_for,
    abort,
)
from cerberus import Validator
from project.web.models.user import User
import json
from project.web.services.mongo_service import get_all
from project.web.services.mongo_service import find_picture
from project.web.services.captcha_generator import generate_captcha

bp = Blueprint("admin", __name__, url_prefix="/admin")

admin_whitelist = ["admin"]


def login_required(view):
    @functools.wraps(view)
    def wrapped_view(**kwargs):
        user_id = session.get("user_id")
        if user_id is None:
            return render_template("403.html")
        user = User.query.filter_by(id=user_id).first()

        if user.role in admin_whitelist:
            return view(**kwargs)
        else:
            return render_template("403.html")

    return wrapped_view


@bp.route("/", methods=("GET", "POST"))
@login_required
def index():
    user_id = session.get("user_id")
    if user_id is not None:
        user = User.query.filter_by(id=user_id).first()
        pictures = get_all()

        c_uuid, c_src = generate_captcha()
        print("AAA")
        return render_template("admin.html", user=user, pictures=pictures)
    else:
        abort(403)


@bp.route("/login", methods=("GET", "POST"))
def login():

    schema = {
        "username": {
            "type": "string",
            "required": True,
            "minlength": 4,
            "maxlength": 10,
        },
        "password": {
            "type": "string",
            "required": True,
            "minlength": 4,
            "maxlength": 10,
        },
        "csrf_token": {"type": "string", "required": True},
    }
    v = Validator(schema)

    if v.validate(request.form.to_dict()) and request.method == "POST":
        username = request.form["username"]
        password = request.form["password"]
        error = None

        user = User.query.filter_by(username=username).first()

        if user is None:
            error = "Incorrect username."
        elif not user.check_password(password):
            error = "Incorrect password."

        if error is None:
            session.clear()
            session["user_id"] = user.id
            flash("Login successfully", "success")
            if user.role == "admin":
                pictures = get_all()
                return render_template("admin.html", user=user, pictures=pictures)
            else:
                pictures = find_picture(user.username)
                response_dict = {"user": user}
                if pictures is not None:
                    response_dict["pictures"] = pictures
                    c_uuid, c_src = generate_captcha()
                    response_dict["captcha_uuid"] = c_uuid
                    response_dict["captcha_src"] = c_src

                return render_template("user.html", **response_dict)

        flash(error)
    else:
        error = json.dumps(v.errors)
    return redirect(url_for("home.index", m_type="error", message=error))


@bp.route("/logout")
def logout():
    message = "Logout successfully"
    session.clear()
    return redirect(url_for("home.index", m_type="info", message=message))

web-app/project/web/routes/errors.py
from flask import render_template


def page_not_found(e):
    return render_template("404.html"), 404

web-app/project/web/routes/home.py
from flask import (
    Blueprint,
    flash,
    jsonify,
    redirect,
    render_template,
    request,
    session,
    url_for,
)
import logging
import os
from project import APP_VERSION, STAGING
from project.web.models.user import User
from project.web.services.file_pipeline import pipeline
from project.web.services.mongo_service import get_picture
from project.web.services.captcha_generator import generate_captcha, check_captcha

bp = Blueprint("home", __name__, url_prefix="/")

ALLOWED_WHITELIST_EXTENSIONS = ["png", "jpg", "jpeg"]

logging.basicConfig(filename="/logging/home.log", level=logging.DEBUG)


@bp.route("/<string:m_type>/<string:message>", methods=("GET", "POST"))
@bp.route("/", methods=("GET", "POST"), defaults={"m_type": None, "message": None})
def index(m_type, message):
    if m_type is not None and message is not None:
        flash(message, m_type)

    terms_accepted = session.get("acceptance_terms")
    if terms_accepted is None or not terms_accepted:
        return render_template("terms.html", app_name="colorize")
    else:
        print("Terms accepted")

    user_id = session.get("user_id")
    if user_id is not None:
        user = User.query.filter_by(id=user_id).first()
    else:
        user = None

    c_uuid, c_src = generate_captcha()
    return render_template(
        "index.html",
        user=user,
        version=APP_VERSION,
        staging=STAGING,
        captcha_uuid=c_uuid,
        captcha_src=c_src,
    )


@bp.route("/terms/<string:acceptance>", methods=("GET", "POST"))
def terms(acceptance):
    print(acceptance)
    if acceptance == "1":
        session["acceptance_terms"] = True
        print("A")
    else:
        session["acceptance_terms"] = False
        print("B")

    return redirect(url_for("home.index"))


@bp.route("/pictureIsReady/<string:object_id>", methods=("GET", "POST"))
def picture_is_ready(object_id):
    print(object_id)
    picture_json = get_picture(object_id)
    if picture_json is None:
        return jsonify({"is_ready": False, "error": "object does not exists"})
    if "error" in picture_json:
        return jsonify(
            {"is_ready": False, "error": True, "object": picture_json["error"]}
        )
        return picture_json
    if "picture_array_color" in picture_json:
        return jsonify(
            {
                "is_ready": True,
                "filename_black": "/static/uploads/black/{}.{}".format(
                    object_id, picture_json["file_format"]
                ),
                "filename_color": "/static/uploads/color/{}.{}".format(
                    object_id, picture_json["file_format"]
                ),
            }
        )
    else:
        return jsonify({"is_ready": False, "error": False})


def delete_captchas_images():
    folderpath = os.getcwd() + "/project/static/uploads/captchas"
    for filename in os.listdir(folderpath):
        if ".png" in filename:
            os.unlink(folderpath + "/" + filename)


@bp.route("upload", methods=("GET", "POST"))
def upload_file():
    def allowed_file(filename):
        return (
            (
                "." in filename
                and filename.rsplit(".", 1)[1].lower() in ALLOWED_WHITELIST_EXTENSIONS
            ),
            filename.rsplit(".", 1)[1].lower(),
        )

    if request.method == "POST":
        logging.debug("A")
        # check captcha

        if session.get('user_id') is None:
            captcha_solved = request.form.get("captcha", None)
            captcha_uuid = request.form.get("captcha_uuid", None)
            if not check_captcha(captcha_uuid, captcha_solved):
                return jsonify({"success": False, "error": "Captcha is not correct"})
            print(captcha_solved)
            print(captcha_uuid)

        # check if the post request has the file part
        if "file" not in request.files:
            flash("No file part")
            return redirect(request.url)
        file = request.files["file"]
        # if user does not select file, browser also
        # submit an empty part without filename
        if file.filename == "":
            flash("No selected file")
            return redirect(request.url)

        is_file_valid, file_format = allowed_file(file.filename)
        if file and is_file_valid:

            user_id = session.get("user_id")
            if user_id is not None:
                user = User.query.filter_by(id=user_id).first()
                username = user.username
            else:
                username = "unknown"
            service_result = pipeline(username, file)
            delete_captchas_images()
            if service_result.executed:
                response = {
                    "success": True,
                    "message": "image saved",
                    "service_result": service_result.to_dict(),
                }
            else:
                response = {"success": False, "message": service_result.error}

            return jsonify(response)
        else:
            return jsonify(
                {
                    "success": False,
                    "error": "Image {} format not supported. Need to be one of {}".format(
                        file_format, ALLOWED_WHITELIST_EXTENSIONS
                    ),
                }
            )

    flash("GET method is not supported")

web-app/project/web/routes/user.py
from flask import Blueprint, render_template, session
from flask import abort
from project.web.models.user import User
from project.web.services.mongo_service import find_picture
from project.web.services.captcha_generator import generate_captcha

bp = Blueprint("user", __name__, url_prefix="/user")


@bp.route("/", methods=("GET", "POST"))
def index():
    user_id = session.get("user_id")
    if user_id is not None:
        user = User.query.filter_by(id=user_id).first()
        pictures = find_picture(user.username)
        response_dict = {"user": user}
        if pictures is not None:
            response_dict["pictures"] = pictures

        c_uuid, c_src = generate_captcha()
        response_dict["captcha_uuid"] = c_uuid
        response_dict["captcha_src"] = c_src
        print("AAA")
        return render_template("user.html", **response_dict)
    else:
        abort(403)

web-app/project/templates/admin.html
<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <title>Colorize your life!</title>
  <script src="{{ url_for('static', filename='js/jquery-3.5.0.js') }}"></script>
  <link href="{{ url_for('static', filename='css/bootstrap.css') }}" rel="stylesheet" />
  <script src="{{ url_for('static', filename='js/bootstrap.js') }}"></script>
  <script src="{{ url_for('static', filename='js/bootstrap.bundle.js') }}"></script>
  <script>
    $(function () {
      $('[data-toggle="tooltip"]').tooltip()
    })
  </script>
  <link href="https://fonts.googleapis.com/css?family=Poppins:400,600&display=swap" rel="stylesheet">
  <link href="{{ url_for('static', filename='css/style.css') }}" rel="stylesheet" />
  <script src="{{ url_for('static', filename='js/particles.min.js') }}"></script>
  <script>
    /* particlesJS.load(@dom-id, @path-json, @callback (optional)); */
    particlesJS.load('particles-js', "{{ url_for('static', filename='js/particlesjs-config.json') }}", function () {
      
    });
  </script>
  <style>
    {% if user is not none %}
    #particles-js {
      position: absolute;
      width: 100%;
      height: 100%;
      background: #f87474;
      z-index: -1;
    }
    {% else %}
    #particles-js {
      position: absolute;
      width: 100%;
      height: 100%;
      background: #838cff;
      z-index: -1;
    }
    {% endif %}
    
  </style>
  {{ toastr.include_toastr_css() }}
  {{ toastr.message() }}
</head>

<body class="bg-light">
  {{ toastr.include_toastr_js() }}
  <div id="particles-js"></div>
  <div class="container-fluid">
    <div class="row">
      <div class="col-12">
        <div class="pt-5 text-center">
          <img class="d-block mx-auto mb-4" src="{{ url_for('static', filename='logo.png') }}" alt="" height="140">
          <h2>Colorize your life!</h2>
          <p class="lead">Admin panel</p>
        </div>
      </div>
    </div>
    {% for picture in pictures %}
    <div class="row m-2">
      <div class="col-12 d-flex justify-content-around">
        <div class="w-50 bg-light p-2">
          <img src="{{picture.picture_array_black}}" class="rounded float-left" style="width: 256px;height: 256px;" alt="...">
          {% if picture.picture_array_color %}
          <img src="{{picture.picture_array_color}}" class="rounded float-right" style="width: 256px;height: 256px;" alt="...">
          {% else %}
          <img src="/static/uploads/loading.gif" class="rounded float-right" style="width: 256px;height: 256px;" alt="...">
          {% endif %}
        </div>
      </div>
    </div>
    {% endfor %}
  </div>

  <div class="row">
    <div class="col-12 d-flex flex-column align-items-center">
      {% if user is not none %}
      <h4>Hello {{user.username}}!</h4>
      <a href="{{ url_for('admin.logout') }}" class="btn btn-primary" data-toggle="tooltip" data-placement="bottom" title="Press here and logout">Logout</a>
      {% endif %}


    </div>
  </div>

  <footer class="my-5 pt-5 text-dark text-center text-small">
    <p class="mb-1">&copy; {{ now.year }} - Colorize</p>
  </footer>
  </div>



</body>

</html>

web-app/project/templates/index.html
<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <title>Colorize your life!</title>
  <script src="{{ url_for('static', filename='js/jquery-3.5.0.js') }}"></script>
  <link href="{{ url_for('static', filename='css/bootstrap.css') }}" rel="stylesheet" />
  <script src="{{ url_for('static', filename='js/bootstrap.js') }}"></script>
  <script src="{{ url_for('static', filename='js/bootstrap.bundle.js') }}"></script>
  <script>
    $(function () {
      $('[data-toggle="tooltip"]').tooltip()
    })
  </script>
  <link href="https://fonts.googleapis.com/css?family=Poppins:400,600&display=swap" rel="stylesheet">
  <link href="{{ url_for('static', filename='css/style.css') }}" rel="stylesheet" />
  <script src="{{ url_for('static', filename='js/particles.min.js') }}"></script>
  <script>
    /* particlesJS.load(@dom-id, @path-json, @callback (optional)); */
    particlesJS.load('particles-js', "{{ url_for('static', filename='js/particlesjs-config.json') }}", function () {

    });
  </script>
  <style>
    .loader {
      border: 16px solid #f3f3f3;
      border-radius: 50%;
      border-top: 16px solid #3498db;
      width: 120px;
      height: 120px;
      -webkit-animation: spin 2s linear infinite; /* Safari */
      animation: spin 2s linear infinite;
    }
    
    /* Safari */
    @-webkit-keyframes spin {
      0% { -webkit-transform: rotate(0deg); }
      100% { -webkit-transform: rotate(360deg); }
    }
    
    @keyframes spin {
      0% { transform: rotate(0deg); }
      100% { transform: rotate(360deg); }
    }
    </style>
  <style>
    {
      % if user is not none %
    }

    #particles-js {
      position: absolute;
      width: 100%;
      height: 100%;
      background: #f87474;
      z-index: -1;
    }

      {
      % else %
    }

    #particles-js {
      position: absolute;
      width: 100%;
      height: 100%;
      background: #838cff;
      z-index: -1;
    }

      {
      % endif %
    }

  /* common */
  .ribbon {
    width: 150px;
    height: 150px;
    overflow: hidden;
    position: absolute;
  }
  .ribbon::before,
  .ribbon::after {
    position: absolute;
    z-index: -1;
    content: '';
    display: block;
    border: 5px solid #000000;
  }
  .ribbon span {
    position: absolute;
    display: block;
    width: 225px;
    padding: 15px 0;
    background-color: #282188;
    box-shadow: 0 5px 10px rgba(0,0,0,.1);
    color: #fff;
    font: 700 .9em'Lato', sans-serif;
    text-shadow: 0 1px 1px rgba(0,0,0,.2);
    text-transform: uppercase;
    text-align: center;
  }

  /* top right*/
  .ribbon-top-right {
    right: -10px;
  }
  .ribbon-top-right::before,
  .ribbon-top-right::after {
    border-top-color: transparent;
    border-right-color: transparent;
  }
  .ribbon-top-right::before {
    top: 0;
    left: 0;
  }
  .ribbon-top-right::after {
    bottom: 0;
    right: 0;
  }
  .ribbon-top-right span {
    left: -25px;
    top: 30px;
    transform: rotate(45deg);
  }



  </style>

{{ toastr.include_toastr_css() }}
{{ toastr.message() }}
</head>

<body class="bg-light">
  {{ toastr.include_toastr_js() }}
  {% if staging == True %}
  <div class="ribbon ribbon-top-right"><span>Staging Cluster</span></div>
  {% endif %}
  <div id="particles-js"></div>
  <div class="container-fluid">
    <div class="row">
      <div class="col-12">
        <div class="pt-5 text-center">
          <img class="d-block mx-auto mb-4" src="{{ url_for('static', filename='logo.png') }}" alt="" height="140">
          <h2>Colorize your life! v{{ version }}</h2>
          <p class="lead">Please, upload a black/white picture</p>
          <small class="text-muted">{{ url }}</small>
        </div>
      </div>
    </div>
    <div class="row" id="drop-row">
      <div class="col-12">
        <div id="drop-area">
          <form class="my-form">
            <img src="{{ captcha_src }}" class="image-fluid m-1"/>
            <input type="hidden" id="captchaUUID" value="{{ captcha_uuid }}"/>
            <input type="text" class="form-control" placeholder="Captcha solver" id="captchaValue"/>
            <p>Drag and drop a picture or just press the button</p>
            <input type="file" id="fileElem" multiple="false" accept="image/jpeg, image/png"
              onchange="handleFiles(this.files)">
            <input type="hidden" name="ajax_csrf_token" value="{{ csrf_token() }}" />

            <label class="btn btn-danger" for="fileElem">Select a picture</label>
            <br>
          </form>
          <!--progress id="progress-bar" max=100 value=0></progress-->
          <div id="gallery" class="text-center" />
        </div>
      </div>
    </div>
  </div>

  <div class="row" id="results-row" style="display:none" >
    <div class="col-12 d-flex justify-content-center">
      <img src="" id="black_picture" class="mr-2 mb-2 rounded" style="width: 256px;height: 256px;" />
      <div class="loader ml-4 mb-4"></div>

      <img src="" id="color_picture" class="ml-2 mb-2 rounded" style="display:none; width: 256px;height: 256px;" />
    </div>
  </div>

  <div class="row">
    <div class="col-12 d-flex flex-column align-items-center">
      {% if user is not none %}
      <h4>Hello {{user.username}}!</h4>
      <a href="{{ url_for('admin.logout') }}" class="btn btn-primary" data-toggle="tooltip" data-placement="bottom"
        title="Press here and logout">Logout</a>
      {% else %}
      <button class="btn btn-primary" data-toggle="tooltip" data-placement="top" title="Are you an Admin user?"
        onclick="$('.modal').modal('show');$('#focus-input').focus()">Login</button>

      {% endif %}


    </div>
  </div>

  <div class="modal" tabindex="-1" role="dialog">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title">Admin Login</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <form action="{{ url_for('admin.login') }}" id="login-form" method="POST">
          <div class="modal-body">
            <input type="hidden" name="csrf_token" value="{{ csrf_token() }}" />
            <input type="text" placeholder="username" name="username" class="form-control" id="focus-input" />
            <input type="password" placeholder="password" name="password" class="mt-2 form-control" />
          </div>
          <div class="modal-footer">
            <button type="submit" class="btn btn-primary">Login</button>
            <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
          </div>
        </form>
      </div>
    </div>
  </div>

  <footer class="my-5 pt-5 text-dark text-center text-small">
    <p class="mb-1">&copy; {{ now.year }} - Colorize</p>
  </footer>

  </div>

  <script>
    var intervalId = null;

    function tryGettingNewPicture(imageId){
      $.ajax({
            type: "GET",
            dataType: "json",
            url: "/pictureIsReady/" + imageId,
        })
        .done(function(data, textStatus, jqXHR) {
            if(data.is_ready){
              console.log("YA ESTA LA FOTOOO");
              $('.loader').hide();
              $('#color_picture').attr('src', data.filename_color);
              $('#color_picture').fadeIn();
              clearInterval(intervalId)
            }else{
              if(data.error){
                console.log("Un problema ha pasado: " + data.error)
              }else{
                console.log("Picture is not ready yet")
              }
            }
        });
    }

    function waitForPredictedPicture(json) {
      json = JSON.parse(json);
      console.log(json);
      if(json.success){
        $('#drop-row').hide();
        imageId = json.service_result.obj.id;
        $('#black_picture').attr('src', json.service_result.obj.filename_black);
        $('#black_picture')
        $('.loader')
        $('#results-row').fadeIn();
        intervalId = setInterval(tryGettingNewPicture, 1000, imageId);
      }else{
        toastr.error(json.error, "error");
        $('#gallery').html("");
      }
    }
  </script>


  <script src="{{ url_for('static', filename='js/script.js') }}"></script>



</body>

</html>

web-app/project/templates/user.html
<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <title>Colorize your life!</title>
  <script src="{{ url_for('static', filename='js/jquery-3.5.0.js') }}"></script>
  <link href="{{ url_for('static', filename='css/bootstrap.css') }}" rel="stylesheet" />
  <script src="{{ url_for('static', filename='js/bootstrap.js') }}"></script>
  <script src="{{ url_for('static', filename='js/bootstrap.bundle.js') }}"></script>
  <script>
    $(function () {
      $('[data-toggle="tooltip"]').tooltip()
    })
  </script>
  <link href="https://fonts.googleapis.com/css?family=Poppins:400,600&display=swap" rel="stylesheet">
  <link href="{{ url_for('static', filename='css/style.css') }}" rel="stylesheet" />
  <script src="{{ url_for('static', filename='js/particles.min.js') }}"></script>
  <script>
    /* particlesJS.load(@dom-id, @path-json, @callback (optional)); */
    particlesJS.load('particles-js', "{{ url_for('static', filename='js/particlesjs-config.json') }}", function () {
      
    });
  </script>
  <style>
    {% if user is not none %}
    #particles-js {
      position: absolute;
      width: 100%;
      height: 100%;
      background: #74f89c;
      z-index: -1;
    }
    {% else %}
    #particles-js {
      position: absolute;
      width: 100%;
      height: 100%;
      background: #838cff;
      z-index: -1;
    }
    {% endif %}
    
  </style>
  {{ toastr.include_toastr_css() }}
  {{ toastr.message() }}
</head>

<body class="bg-light">
  {{ toastr.include_toastr_js() }}
  <div id="particles-js"></div>
  

  <div class="container-fluid">
    <div class="row">
      <div class="col-12">
        <div class="pt-5 text-center">
          <img class="d-block mx-auto mb-4" src="{{ url_for('static', filename='logo.png') }}" alt="" height="140">
          <h2>Colorize your life!</h2>
          <p class="lead">{{user.username}} panel</p>
        </div>
      </div>
    </div>
    <div class="row" id="results-row" style="display:none" >
      <div class="col-12 d-flex justify-content-center">
        <img src="" id="black_picture" class="mr-2 mb-2 rounded" style="width: 256px;height: 256px;" />
        <div class="loader ml-4 mb-4"></div>
  
        <img src="" id="color_picture" class="ml-2 mb-2 rounded" style="display:none; width: 256px;height: 256px;" />
      </div>
    </div>
    <div class="row" id="drop-row">
      <div class="col-12">
        <div id="drop-area">
          <form class="my-form">
            <p>Drag and drop a picture or just press the button</p>
            <input type="file" id="fileElem" multiple="false" accept="image/jpeg, image/png"
              onchange="handleFiles(this.files)">
            <input type="hidden" name="ajax_csrf_token" value="{{ csrf_token() }}" />

            <label class="btn btn-danger" for="fileElem">Select a picture</label>
          </form>
          <!--progress id="progress-bar" max=100 value=0></progress-->
          <div id="gallery" class="text-center" ></div>
        </div>
      </div>
    </div>
    {% for picture in pictures %}
    <div class="row m-2">
      <div class="col-12 d-flex justify-content-around">
        <div class="w-50 bg-light p-2">
          <h4 class="text-center"><a href="{{picture._id}}">{{picture.date.strftime('%d-%m-%Y %H:%M:%S')}}</a></h4>
          <img src="{{picture.picture_array_black }}" class="rounded float-left" style="width: 256px;height: 256px;"  alt="...">
          <img src="{{ picture.picture_array_color }}" class="rounded float-right" style="width: 256px;height: 256px;" alt="...">
        </div>
      </div>
    </div>
    {% endfor %}
  </div>

  
  <div class="row">
    <div class="col-12 d-flex flex-column align-items-center">
      {% if user is not none %}
      <h4>Hello {{user.username}}!</h4>
      <a href="{{ url_for('admin.logout') }}" class="btn btn-primary" data-toggle="tooltip" data-placement="bottom" title="Press here and logout">Logout</a>
      {% endif %}


    </div>
  </div>

  <footer class="my-5 pt-5 text-dark text-center text-small">
    <p class="mb-1">&copy; {{ now.year }} - Colorize</p>
  </footer>
  </div>

  <script>
    var intervalId = null;

    function tryGettingNewPicture(imageId){
      $.ajax({
            type: "GET",
            dataType: "json",
            url: "/pictureIsReady/" + imageId,
        })
        .done(function(data, textStatus, jqXHR) {
            if(data.is_ready){
              console.log("YA ESTA LA FOTOOO");
              $('.loader').hide();
              $('#color_picture').attr('src', data.filename_color);
              $('#color_picture').fadeIn();
              clearInterval(intervalId)
            }else{
              if(data.error){
                console.log("Un problema ha pasado: " + data.error)
              }else{
                console.log("Picture is not ready yet")
              }
            }
        });
    }

    function waitForPredictedPicture(json) {
      $('#drop-row').hide();
      json = JSON.parse(json);
      console.log(json);
      if(json.success){
        imageId = json.service_result.obj.id;
        $('#black_picture').attr('src', json.service_result.obj.filename_black);
        $('#black_picture')
        $('.loader')
        $('#results-row').fadeIn();
        intervalId = setInterval(tryGettingNewPicture, 1000, imageId);
      }else{
        toastr.error(json.error, "error");
      }
      
    }
  </script>


  <script src="{{ url_for('static', filename='js/script.js') }}"></script>

</body>

</html>